fix(uti): Fixing broken code part IV
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2022 Cisco and/or its affiliates.
2 # Copyright (c) 2022 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96 }
97
98
99 function activate_virtualenv () {
100
101     # Update virtualenv pip package, delete and create virtualenv directory,
102     # activate the virtualenv, install requirements, set PYTHONPATH.
103
104     # Arguments:
105     # - ${1} - Path to existing directory for creating virtualenv in.
106     #          If missing or empty, ${CSIT_DIR} is used.
107     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
108     # Variables read:
109     # - CSIT_DIR - Path to existing root of local CSIT git repository.
110     # Variables exported:
111     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
112     # Functions called:
113     # - die - Print to stderr and exit.
114
115     set -exuo pipefail
116
117     root_path="${1-$CSIT_DIR}"
118     env_dir="${root_path}/env"
119     req_path=${2-$CSIT_DIR/requirements.txt}
120     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
121     pip3 install virtualenv==20.0.20 || {
122         die "Virtualenv package install failed."
123     }
124     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
125         die "Virtualenv creation for $(which python3) failed."
126     }
127     set +u
128     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
129     set -u
130     pip3 install -r "${req_path}" || {
131         die "Requirements installation failed."
132     }
133     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
134     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
135 }
136
137
138 function archive_tests () {
139
140     # Create .tar.gz of generated/tests for archiving.
141     # To be run after generate_tests, kept separate to offer more flexibility.
142
143     # Directory read:
144     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
145     # File rewriten:
146     # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
147
148     set -exuo pipefail
149
150     pushd "${ARCHIVE_DIR}" || die
151     tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
152     popd || die
153 }
154
155
156 function check_download_dir () {
157
158     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
159     #
160     # Variables read:
161     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
162     # Directories read:
163     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
164     # Functions called:
165     # - die - Print to stderr and exit.
166
167     set -exuo pipefail
168
169     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
170         die "No artifacts downloaded!"
171     fi
172 }
173
174
175 function check_prerequisites () {
176
177     # Fail if prerequisites are not met.
178     #
179     # Functions called:
180     # - installed - Check if application is installed/present in system.
181     # - die - Print to stderr and exit.
182
183     set -exuo pipefail
184
185     if ! installed sshpass; then
186         die "Please install sshpass before continue!"
187     fi
188 }
189
190
191 function common_dirs () {
192
193     # Set global variables, create some directories (without touching content).
194
195     # Variables set:
196     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
197     # - CSIT_DIR - Path to existing root of local CSIT git repository.
198     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
199     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
200     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
201     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
202     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
203     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
204     #   The name is chosen to match what ci-management expects.
205     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
206     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
207     # Directories created if not present:
208     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
209     # Functions called:
210     # - die - Print to stderr and exit.
211
212     set -exuo pipefail
213
214     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
215         die "Some error during locating of this source file."
216     }
217     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
218         die "Some error during dirname call."
219     }
220     # Current working directory could be in a different repo, e.g. VPP.
221     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
222     relative_csit_dir=$(git rev-parse --show-toplevel) || {
223         die "Git rev-parse failed."
224     }
225     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
226     popd || die "Popd failed."
227     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
228         die "Readlink failed."
229     }
230     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
231         die "Readlink failed."
232     }
233     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
234         die "Readlink failed."
235     }
236     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
237         die "Readlink failed."
238     }
239     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
240         die "Readlink failed."
241     }
242     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
243         die "Readlink failed."
244     }
245
246     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
247         die "Readlink failed."
248     }
249     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
250     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
251         die "Readlink failed."
252     }
253     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
254     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
255         die "Readlink failed."
256     }
257     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
258 }
259
260
261 function compose_pybot_arguments () {
262
263     # Variables read:
264     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
265     # - DUT - CSIT test/ subdirectory, set while processing tags.
266     # - TAGS - Array variable holding selected tag boolean expressions.
267     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
268     # - TEST_CODE - The test selection string from environment or argument.
269     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
270     # Variables set:
271     # - PYBOT_ARGS - String holding part of all arguments for pybot.
272     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
273
274     set -exuo pipefail
275
276     # No explicit check needed with "set -u".
277     PYBOT_ARGS=("--loglevel" "TRACE")
278     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
279
280     case "${TEST_CODE}" in
281         *"device"*)
282             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
283             ;;
284         *"perf"*)
285             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
286             ;;
287         *)
288             die "Unknown specification: ${TEST_CODE}"
289     esac
290
291     EXPANDED_TAGS=()
292     for tag in "${TAGS[@]}"; do
293         if [[ ${tag} == "!"* ]]; then
294             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
295         else
296             if [[ ${SELECTION_MODE} == "--test" ]]; then
297                 EXPANDED_TAGS+=("--test" "${tag}")
298             else
299                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
300             fi
301         fi
302     done
303
304     if [[ ${SELECTION_MODE} == "--test" ]]; then
305         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
306     fi
307 }
308
309
310 function deactivate_docker_topology () {
311
312     # Deactivate virtual vpp-device topology by removing containers.
313     #
314     # Variables read:
315     # - NODENESS - Node multiplicity of desired testbed.
316     # - FLAVOR - Node flavor string, usually describing the processor.
317
318     set -exuo pipefail
319
320     case_text="${NODENESS}_${FLAVOR}"
321     case "${case_text}" in
322         "1n_skx" | "1n_tx2")
323             ssh="ssh root@172.17.0.1 -p 6022"
324             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
325             # The "declare -f" output is long and boring.
326             set +x
327             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
328                 die "Topology cleanup via shim-dcr failed!"
329             }
330             set -x
331             ;;
332         "1n_vbox")
333             enter_mutex || die
334             clean_environment || {
335                 die "Topology cleanup locally failed!"
336             }
337             exit_mutex || die
338             ;;
339         *)
340             die "Unknown specification: ${case_text}!"
341     esac
342 }
343
344
345 function die () {
346
347     # Print the message to standard error end exit with error code specified
348     # by the second argument.
349     #
350     # Hardcoded values:
351     # - The default error message.
352     # Arguments:
353     # - ${1} - The whole error message, be sure to quote. Optional
354     # - ${2} - the code to exit with, default: 1.
355
356     set -x
357     set +eu
358     warn "${1:-Unspecified run-time error occurred!}"
359     exit "${2:-1}"
360 }
361
362
363 function die_on_pybot_error () {
364
365     # Source this fragment if you want to abort on any failed test case.
366     #
367     # Variables read:
368     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
369     # Functions called:
370     # - die - Print to stderr and exit.
371
372     set -exuo pipefail
373
374     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
375         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
376     fi
377 }
378
379
380 function generate_tests () {
381
382     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
383     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
384     # The generation is done by executing any *.py executable
385     # within any subdirectory after copying.
386
387     # This is a separate function, because this code is called
388     # both by autogen checker and entries calling run_pybot.
389
390     # Directories read:
391     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
392     # Directories replaced:
393     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
394
395     set -exuo pipefail
396
397     rm -rf "${GENERATED_DIR}/tests" || die
398     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
399     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
400     cmd_line+=("-executable" "-name" "*.py")
401     # We sort the directories, so log output can be compared between runs.
402     file_list=$("${cmd_line[@]}" | sort) || die
403
404     for gen in ${file_list}; do
405         directory="$(dirname "${gen}")" || die
406         filename="$(basename "${gen}")" || die
407         pushd "${directory}" || die
408         ./"${filename}" || die
409         popd || die
410     done
411 }
412
413
414 function get_test_code () {
415
416     # Arguments:
417     # - ${1} - Optional, argument of entry script (or empty as unset).
418     #   Test code value to override job name from environment.
419     # Variables read:
420     # - JOB_NAME - String affecting test selection, default if not argument.
421     # Variables set:
422     # - TEST_CODE - The test selection string from environment or argument.
423     # - NODENESS - Node multiplicity of desired testbed.
424     # - FLAVOR - Node flavor string, usually describing the processor.
425
426     set -exuo pipefail
427
428     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
429     if [[ -z "${TEST_CODE}" ]]; then
430         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
431     fi
432
433     case "${TEST_CODE}" in
434         *"1n-vbox"*)
435             NODENESS="1n"
436             FLAVOR="vbox"
437             ;;
438         *"1n-skx"*)
439             NODENESS="1n"
440             FLAVOR="skx"
441             ;;
442        *"1n-tx2"*)
443             NODENESS="1n"
444             FLAVOR="tx2"
445             ;;
446         *"2n-aws"*)
447             NODENESS="2n"
448             FLAVOR="aws"
449             ;;
450         *"3n-aws"*)
451             NODENESS="3n"
452             FLAVOR="aws"
453             ;;
454         *"2n-skx"*)
455             NODENESS="2n"
456             FLAVOR="skx"
457             ;;
458         *"2n-zn2"*)
459             NODENESS="2n"
460             FLAVOR="zn2"
461             ;;
462         *"3n-skx"*)
463             NODENESS="3n"
464             FLAVOR="skx"
465             ;;
466         *"2n-clx"*)
467             NODENESS="2n"
468             FLAVOR="clx"
469             ;;
470         *"2n-dnv"*)
471             NODENESS="2n"
472             FLAVOR="dnv"
473             ;;
474         *"3n-dnv"*)
475             NODENESS="3n"
476             FLAVOR="dnv"
477             ;;
478         *"2n-tx2"*)
479             NODENESS="2n"
480             FLAVOR="tx2"
481             ;;
482         *"3n-tsh"*)
483             NODENESS="3n"
484             FLAVOR="tsh"
485             ;;
486     esac
487 }
488
489
490 function get_test_tag_string () {
491
492     # Variables read:
493     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
494     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
495     # - TEST_CODE - The test selection string from environment or argument.
496     # Variables set:
497     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
498     #   May be empty, or even not set on event types not adding comment.
499
500     # TODO: ci-management scripts no longer need to perform this.
501
502     set -exuo pipefail
503
504     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
505         case "${TEST_CODE}" in
506             *"device"*)
507                 trigger="devicetest"
508                 ;;
509             *"perf"*)
510                 trigger="perftest"
511                 ;;
512             *)
513                 die "Unknown specification: ${TEST_CODE}"
514         esac
515         # Ignore lines not containing the trigger word.
516         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
517         # The vpp-csit triggers trail stuff we are not interested in.
518         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
519         # (except relying on \s whitespace, \S non-whitespace and . both).
520         # The last string is concatenated, only the middle part is expanded.
521         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
522         # On parsing error, TEST_TAG_STRING probably stays empty.
523         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
524         if [[ -z "${TEST_TAG_STRING-}" ]]; then
525             # Probably we got a base64 encoded comment.
526             comment="${GERRIT_EVENT_COMMENT_TEXT}"
527             comment=$(base64 --decode <<< "${comment}" || true)
528             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
529             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
530         fi
531         if [[ -n "${TEST_TAG_STRING-}" ]]; then
532             test_tag_array=(${TEST_TAG_STRING})
533             if [[ "${test_tag_array[0]}" == "icl" ]]; then
534                 export GRAPH_NODE_VARIANT="icl"
535                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
536             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
537                 export GRAPH_NODE_VARIANT="skx"
538                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
539             fi
540         fi
541     fi
542 }
543
544
545 function installed () {
546
547     # Check if the given utility is installed. Fail if not installed.
548     #
549     # Duplicate of common.sh function, as this file is also used standalone.
550     #
551     # Arguments:
552     # - ${1} - Utility to check.
553     # Returns:
554     # - 0 - If command is installed.
555     # - 1 - If command is not installed.
556
557     set -exuo pipefail
558
559     command -v "${1}"
560 }
561
562
563 function move_archives () {
564
565     # Move archive directory to top of workspace, if not already there.
566     #
567     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
568     # but in some jobs CSIT_DIR is not same as WORKSPACE
569     # (e.g. under VPP_DIR). To simplify ci-management settings,
570     # we want to move the data to the top. We do not want simple copy,
571     # as ci-management is eager with recursive search.
572     #
573     # As some scripts may call this function multiple times,
574     # the actual implementation use copying and deletion,
575     # so the workspace gets "union" of contents (except overwrites on conflict).
576     # The consequence is empty ARCHIVE_DIR remaining after this call.
577     #
578     # As the source directory is emptied,
579     # the check for dirs being different is essential.
580     #
581     # Variables read:
582     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
583     #   Can be unset, then it speeds up manual testing.
584     # - ARCHIVE_DIR - Path to directory with content to be moved.
585     # Directories updated:
586     # - ${WORKSPACE}/archives/ - Created if does not exist.
587     #   Content of ${ARCHIVE_DIR}/ is moved.
588     # Functions called:
589     # - die - Print to stderr and exit.
590
591     set -exuo pipefail
592
593     if [[ -n "${WORKSPACE-}" ]]; then
594         target=$(readlink -f "${WORKSPACE}/archives")
595         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
596             mkdir -p "${target}" || die "Archives dir create failed."
597             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
598             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
599         fi
600     fi
601 }
602
603
604 function post_process_robot_outputs () {
605
606     # Generate INFO level output_info.xml by rebot.
607     # Archive UTI raw json outputs.
608     #
609     # Variables read:
610     # - ARCHIVE_DIR - Path to post-processed files.
611
612     set -exuo pipefail
613
614     # Compress raw json outputs, as they will never be post-processed.
615     pushd "${ARCHIVE_DIR}" || die
616     if [ -d "tests" ]; then
617         # Use deterministic order.
618         options+=("--sort=name")
619         # We are keeping info outputs where they are.
620         # Assuming we want to move anything but info files (and dirs).
621         options+=("--exclude=*.info.json")
622         tar czf "generated_output_raw.tar.gz" "${options[@]}" "tests" || true
623         # Tar can remove when archiving, but chokes (not deterministically)
624         # on attempting to remove dirs (not empty as info files are there).
625         # So we need to delete the raw files manually.
626         find "tests" -type f -name "*.raw.json" -delete || true
627     fi
628     popd || die
629
630     # Generate INFO level output_info.xml for post-processing.
631     all_options=("--loglevel" "INFO")
632     all_options+=("--log" "none")
633     all_options+=("--report" "none")
634     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
635     all_options+=("${ARCHIVE_DIR}/output.xml")
636     rebot "${all_options[@]}" || true
637 }
638
639
640 function prepare_topology () {
641
642     # Prepare virtual testbed topology if needed based on flavor.
643
644     # Variables read:
645     # - TEST_CODE - String affecting test selection, usually jenkins job name.
646     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
647     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
648     # Functions called:
649     # - die - Print to stderr and exit.
650     # - terraform_init - Terraform init topology.
651     # - terraform_apply - Terraform apply topology.
652
653     set -exuo pipefail
654
655     case_text="${NODENESS}_${FLAVOR}"
656     case "${case_text}" in
657         "2n_aws")
658             export TF_VAR_testbed_name="${TEST_CODE}"
659             terraform_init || die "Failed to call terraform init."
660             terraform_apply || die "Failed to call terraform apply."
661             ;;
662         "3n_aws")
663             export TF_VAR_testbed_name="${TEST_CODE}"
664             terraform_init || die "Failed to call terraform init."
665             terraform_apply || die "Failed to call terraform apply."
666             ;;
667     esac
668 }
669
670
671 function reserve_and_cleanup_testbed () {
672
673     # Reserve physical testbed, perform cleanup, register trap to unreserve.
674     # When cleanup fails, remove from topologies and keep retrying
675     # until all topologies are removed.
676     #
677     # Variables read:
678     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
679     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
680     # - BUILD_TAG - Any string suitable as filename, identifying
681     #   test run executing this function. May be unset.
682     # Variables set:
683     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
684     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
685     # Functions called:
686     # - die - Print to stderr and exit.
687     # - ansible_playbook - Perform an action using ansible, see ansible.sh
688     # Traps registered:
689     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
690
691     set -exuo pipefail
692
693     while true; do
694         for topo in "${TOPOLOGIES[@]}"; do
695             set +e
696             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
697             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
698             python3 "${scrpt}" "${opts[@]}"
699             result="$?"
700             set -e
701             if [[ "${result}" == "0" ]]; then
702                 # Trap unreservation before cleanup check,
703                 # so multiple jobs showing failed cleanup improve chances
704                 # of humans to notice and fix.
705                 WORKING_TOPOLOGY="${topo}"
706                 echo "Reserved: ${WORKING_TOPOLOGY}"
707                 trap "untrap_and_unreserve_testbed" EXIT || {
708                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
709                     untrap_and_unreserve_testbed "${message}" || {
710                         die "Teardown should have died, not failed."
711                     }
712                     die "Trap attempt failed, unreserve succeeded. Aborting."
713                 }
714                 # Cleanup + calibration checks
715                 set +e
716                 ansible_playbook "cleanup, calibration"
717                 result="$?"
718                 set -e
719                 if [[ "${result}" == "0" ]]; then
720                     break
721                 fi
722                 warn "Testbed cleanup failed: ${topo}"
723                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
724             fi
725             # Else testbed is accessible but currently reserved, moving on.
726         done
727
728         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
729             # Exit the infinite while loop if we made a reservation.
730             warn "Reservation and cleanup successful."
731             break
732         fi
733
734         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
735             die "Run out of operational testbeds!"
736         fi
737
738         # Wait ~3minutes before next try.
739         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
740             die "Sleep time calculation failed."
741         }
742         echo "Sleeping ${sleep_time}"
743         sleep "${sleep_time}" || die "Sleep failed."
744     done
745 }
746
747
748 function run_pybot () {
749
750     # Run pybot with options based on input variables.
751     # Generate INFO level output_info.xml by rebot.
752     # Archive UTI raw json outputs.
753     #
754     # Variables read:
755     # - CSIT_DIR - Path to existing root of local CSIT git repository.
756     # - ARCHIVE_DIR - Path to store robot result files in.
757     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
758     # - GENERATED_DIR - Tests are assumed to be generated under there.
759     # Variables set:
760     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
761     # Functions called:
762     # - die - Print to stderr and exit.
763
764     set -exuo pipefail
765
766     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
767     all_options+=("--noncritical" "EXPECTED_FAILING")
768     all_options+=("${EXPANDED_TAGS[@]}")
769
770     pushd "${CSIT_DIR}" || die "Change directory operation failed."
771     set +e
772     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
773     PYBOT_EXIT_STATUS="$?"
774     set -e
775
776     post_process_robot_outputs || die
777
778     popd || die "Change directory operation failed."
779 }
780
781
782 function select_arch_os () {
783
784     # Set variables affected by local CPU architecture and operating system.
785     #
786     # Variables set:
787     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
788     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
789     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
790
791     set -exuo pipefail
792
793     source /etc/os-release || die "Get OS release failed."
794
795     case "${ID}" in
796         "ubuntu"*)
797             case "${VERSION}" in
798                 *"LTS (Focal Fossa)"*)
799                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
800                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_FOCAL"
801                     PKG_SUFFIX="deb"
802                     ;;
803                 *)
804                     die "Unsupported Ubuntu version!"
805                     ;;
806             esac
807             ;;
808         *)
809             die "Unsupported distro or OS!"
810             ;;
811     esac
812
813     arch=$(uname -m) || {
814         die "Get CPU architecture failed."
815     }
816
817     case "${arch}" in
818         "aarch64")
819             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
820             ;;
821         *)
822             ;;
823     esac
824 }
825
826
827 function select_tags () {
828
829     # Variables read:
830     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
831     # - TEST_CODE - String affecting test selection, usually jenkins job name.
832     # - DUT - CSIT test/ subdirectory, set while processing tags.
833     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
834     #   Can be unset.
835     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
836     # - BASH_FUNCTION_DIR - Directory with input files to process.
837     # Variables set:
838     # - TAGS - Array of processed tag boolean expressions.
839     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
840
841     set -exuo pipefail
842
843     # NIC SELECTION
844     start_pattern='^  TG:'
845     end_pattern='^ \? \?[A-Za-z0-9]\+:'
846     # Remove the TG section from topology file
847     sed_command="/${start_pattern}/,/${end_pattern}/d"
848     # All topologies DUT NICs
849     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
850                 | grep -hoP "model: \K.*" | sort -u)
851     # Selected topology DUT NICs
852     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
853                | grep -hoP "model: \K.*" | sort -u)
854     # All topologies DUT NICs - Selected topology DUT NICs
855     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
856         die "Computation of excluded NICs failed."
857     }
858
859     # Select default NIC tag.
860     case "${TEST_CODE}" in
861         *"3n-dnv"* | *"2n-dnv"*)
862             default_nic="nic_intel-x553"
863             ;;
864         *"3n-tsh"*)
865             default_nic="nic_intel-x520-da2"
866             ;;
867         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
868             default_nic="nic_intel-xxv710"
869             ;;
870         *"2n-tx2"* | *"mrr-daily-master")
871             default_nic="nic_intel-xl710"
872             ;;
873         *"2n-aws"* | *"3n-aws"*)
874             default_nic="nic_amazon-nitro-50g"
875             ;;
876         *)
877             default_nic="nic_intel-x710"
878             ;;
879     esac
880
881     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
882     awk_nics_sub_cmd=""
883     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
884     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
885     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
886     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
887     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
888     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
889     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
890     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
891     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
892     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
893     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
894     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
895     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
896     awk_nics_sub_cmd+='else drv="";'
897     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
898     awk_nics_sub_cmd+='else cores=$1;'
899     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
900
901     # Tag file directory shorthand.
902     tfd="${JOB_SPECS_DIR}"
903     case "${TEST_CODE}" in
904         # Select specific performance tests based on jenkins job type variable.
905         *"device"* )
906             readarray -t test_tag_array <<< $(grep -v "#" \
907                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
908                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
909             SELECTION_MODE="--test"
910             ;;
911         *"ndrpdr-weekly"* )
912             readarray -t test_tag_array <<< $(grep -v "#" \
913                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
914                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
915             SELECTION_MODE="--test"
916             ;;
917         *"mrr-daily"* )
918             readarray -t test_tag_array <<< $(grep -v "#" \
919                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
920                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
921             SELECTION_MODE="--test"
922             ;;
923         *"mrr-weekly"* )
924             readarray -t test_tag_array <<< $(grep -v "#" \
925                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
926                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
927             SELECTION_MODE="--test"
928             ;;
929         *"report-iterative"* )
930             test_sets=(${TEST_TAG_STRING//:/ })
931             # Run only one test set per run
932             report_file=${test_sets[0]}.md
933             readarray -t test_tag_array <<< $(grep -v "#" \
934                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
935                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
936             SELECTION_MODE="--test"
937             ;;
938         *"report-coverage"* )
939             test_sets=(${TEST_TAG_STRING//:/ })
940             # Run only one test set per run
941             report_file=${test_sets[0]}.md
942             readarray -t test_tag_array <<< $(grep -v "#" \
943                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
944                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
945             SELECTION_MODE="--test"
946             ;;
947         * )
948             if [[ -z "${TEST_TAG_STRING-}" ]]; then
949                 # If nothing is specified, we will run pre-selected tests by
950                 # following tags.
951                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
952                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
953                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
954                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
955                                 "!drv_af_xdp" "!drv_avf")
956             else
957                 # If trigger contains tags, split them into array.
958                 test_tag_array=(${TEST_TAG_STRING//:/ })
959             fi
960             SELECTION_MODE="--include"
961             ;;
962     esac
963
964     # Blacklisting certain tags per topology.
965     #
966     # Reasons for blacklisting:
967     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
968     case "${TEST_CODE}" in
969         *"1n-vbox"*)
970             test_tag_array+=("!avf")
971             test_tag_array+=("!vhost")
972             test_tag_array+=("!flow")
973             ;;
974         *"1n_tx2"*)
975             test_tag_array+=("!flow")
976             ;;
977         *"2n-skx"*)
978             test_tag_array+=("!ipsechw")
979             ;;
980         *"3n-skx"*)
981             test_tag_array+=("!ipsechw")
982             # Not enough nic_intel-xxv710 to support double link tests.
983             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
984             ;;
985         *"2n-clx"*)
986             test_tag_array+=("!ipsechw")
987             ;;
988         *"2n-zn2"*)
989             test_tag_array+=("!ipsechw")
990             ;;
991         *"2n-dnv"*)
992             test_tag_array+=("!memif")
993             test_tag_array+=("!srv6_proxy")
994             test_tag_array+=("!vhost")
995             test_tag_array+=("!vts")
996             test_tag_array+=("!drv_avf")
997             ;;
998         *"2n-tx2"*)
999             test_tag_array+=("!ipsechw")
1000             ;;
1001         *"3n-dnv"*)
1002             test_tag_array+=("!memif")
1003             test_tag_array+=("!srv6_proxy")
1004             test_tag_array+=("!vhost")
1005             test_tag_array+=("!vts")
1006             test_tag_array+=("!drv_avf")
1007             ;;
1008         *"3n-tsh"*)
1009             # 3n-tsh only has x520 NICs which don't work with AVF
1010             test_tag_array+=("!drv_avf")
1011             test_tag_array+=("!ipsechw")
1012             ;;
1013         *"2n-aws"* | *"3n-aws"*)
1014             test_tag_array+=("!ipsechw")
1015             ;;
1016     esac
1017
1018     # We will add excluded NICs.
1019     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1020
1021     TAGS=()
1022     prefix=""
1023
1024     set +x
1025     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1026         if [[ "${TEST_CODE}" != *"device"* ]]; then
1027             # Automatic prefixing for VPP perf jobs to limit the NIC used and
1028             # traffic evaluation to MRR.
1029             if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
1030                 prefix="${prefix}mrrAND"
1031             else
1032                 prefix="${prefix}mrrAND${default_nic}AND"
1033             fi
1034         fi
1035     fi
1036     for tag in "${test_tag_array[@]}"; do
1037         if [[ "${tag}" == "!"* ]]; then
1038             # Exclude tags are not prefixed.
1039             TAGS+=("${tag}")
1040         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1041             # Badly formed tag expressions can trigger way too much tests.
1042             set -x
1043             warn "The following tag expression hints at bad trigger: ${tag}"
1044             warn "Possible cause: Multiple triggers in a single comment."
1045             die "Aborting to avoid triggering too many tests."
1046         elif [[ "${tag}" == *"OR"* ]]; then
1047             # If OR had higher precedence than AND, it would be useful here.
1048             # Some people think it does, thus triggering way too much tests.
1049             set -x
1050             warn "The following tag expression hints at bad trigger: ${tag}"
1051             warn "Operator OR has lower precedence than AND. Use space instead."
1052             die "Aborting to avoid triggering too many tests."
1053         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1054             # Empty and comment lines are skipped.
1055             # Other lines are normal tags, they are to be prefixed.
1056             TAGS+=("${prefix}${tag}")
1057         fi
1058     done
1059     set -x
1060 }
1061
1062
1063 function select_topology () {
1064
1065     # Variables read:
1066     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1067     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1068     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1069     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1070     # Variables set:
1071     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1072     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1073     # Functions called:
1074     # - die - Print to stderr and exit.
1075
1076     set -exuo pipefail
1077
1078     case_text="${NODENESS}_${FLAVOR}"
1079     case "${case_text}" in
1080         "1n_vbox")
1081             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1082             TOPOLOGIES_TAGS="2_node_single_link_topo"
1083             ;;
1084         "1n_skx" | "1n_tx2")
1085             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1086             TOPOLOGIES_TAGS="2_node_single_link_topo"
1087             ;;
1088         "2n_skx")
1089             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1090             TOPOLOGIES_TAGS="2_node_*_link_topo"
1091             ;;
1092         "2n_zn2")
1093             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1094             TOPOLOGIES_TAGS="2_node_*_link_topo"
1095             ;;
1096         "3n_skx")
1097             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1098             TOPOLOGIES_TAGS="3_node_*_link_topo"
1099             ;;
1100         "2n_clx")
1101             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1102             TOPOLOGIES_TAGS="2_node_*_link_topo"
1103             ;;
1104         "2n_dnv")
1105             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1106             TOPOLOGIES_TAGS="2_node_single_link_topo"
1107             ;;
1108         "3n_dnv")
1109             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1110             TOPOLOGIES_TAGS="3_node_single_link_topo"
1111             ;;
1112         "3n_tsh")
1113             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1114             TOPOLOGIES_TAGS="3_node_single_link_topo"
1115             ;;
1116         "2n_tx2")
1117             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1118             TOPOLOGIES_TAGS="2_node_single_link_topo"
1119             ;;
1120         "2n_aws")
1121             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_aws*.yaml )
1122             TOPOLOGIES_TAGS="2_node_single_link_topo"
1123             ;;
1124         "3n_aws")
1125             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_aws*.yaml )
1126             TOPOLOGIES_TAGS="3_node_single_link_topo"
1127             ;;
1128         *)
1129             # No falling back to default, that should have been done
1130             # by the function which has set NODENESS and FLAVOR.
1131             die "Unknown specification: ${case_text}"
1132     esac
1133
1134     if [[ -z "${TOPOLOGIES-}" ]]; then
1135         die "No applicable topology found!"
1136     fi
1137 }
1138
1139
1140 function set_environment_variables () {
1141
1142     # Depending on testbed topology, overwrite defaults set in the
1143     # resources/libraries/python/Constants.py file
1144     #
1145     # Variables read:
1146     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1147     # Variables set:
1148     # See specific cases
1149
1150     set -exuo pipefail
1151
1152     case "${TEST_CODE}" in
1153         *"2n-aws"* | *"3n-aws"*)
1154             # T-Rex 2.88 workaround for ENA NICs
1155             export TREX_RX_DESCRIPTORS_COUNT=1024
1156             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1157             export TREX_CORE_COUNT=6
1158             # Settings to prevent duration stretching
1159             export PERF_TRIAL_STL_DELAY=0.1
1160             ;;
1161     esac
1162 }
1163
1164
1165 function untrap_and_unreserve_testbed () {
1166
1167     # Use this as a trap function to ensure testbed does not remain reserved.
1168     # Perhaps call directly before script exit, to free testbed for other jobs.
1169     # This function is smart enough to avoid multiple unreservations (so safe).
1170     # Topo cleanup is executed (call it best practice), ignoring failures.
1171     #
1172     # Hardcoded values:
1173     # - default message to die with if testbed might remain reserved.
1174     # Arguments:
1175     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1176     # Variables read (by inner function):
1177     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1178     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1179     # Variables written:
1180     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1181     # Trap unregistered:
1182     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1183     # Functions called:
1184     # - die - Print to stderr and exit.
1185     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1186
1187     set -xo pipefail
1188     set +eu  # We do not want to exit early in a "teardown" function.
1189     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1190     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1191     if [[ -z "${wt-}" ]]; then
1192         set -eu
1193         warn "Testbed looks unreserved already. Trap removal failed before?"
1194     else
1195         ansible_playbook "cleanup" || true
1196         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1197             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1198         }
1199         case "${TEST_CODE}" in
1200             *"2n-aws"* | *"3n-aws"*)
1201                 terraform_destroy || die "Failed to call terraform destroy."
1202                 ;;
1203             *)
1204                 ;;
1205         esac
1206         WORKING_TOPOLOGY=""
1207         set -eu
1208     fi
1209 }
1210
1211
1212 function warn () {
1213
1214     # Print the message to standard error.
1215     #
1216     # Arguments:
1217     # - ${@} - The text of the message.
1218
1219     set -exuo pipefail
1220
1221     echo "$@" >&2
1222 }